;***************************************************************
;
;***************************************************************
.model small
skBufDydis		EQU 121				
.stack 100h

.data
	duomvisi	DB 256 dup (0) 			;visu duomenu failu vardai
   	duom     	DB 20 dup (0)  			;einamojo duomenu failo vardas (bloko vardas)
	dfail   	DW ? 		  		;cia talpinsim duom failo varda
	rfail   	DW ?		 		;cia talpinsim rez failo varda

	skbuf 		DB skBufDydis dup (?)		;skaitymo buferis

	error_msg 	DB "Klaida kuriant/atidarant faila!$"
	helpas 		DB "Komandu eiluteje nurodyti skaidymo skaiciu ir vardinti failus, atskirtus tarpais, pvz 20 failas.txt duomenys.txt$"
	info		DB "-------------------------------------------$"
	
	kiekis      	DB ?				;bus irasyta po kiek skaidyti failus
	kiekissk	DW ?				;bus irasyta keliu skaitmenu yra kiekis
	deci		DW 10				;naudojama skaitant "kiekis"
	spausdsk	DB 0  				;failo indeksas (kur eina pries bloka, pvz 1failas.txt)
	pasksimb    	DB 0 				;paskutinis simbolis, naudojamas paziureti ar dar ne parametru galas
	simblike    	DW 0 				;spausdinant cia saugosim likusiu simboliu skaiciu
	simbbuve    	DW 0				;spausdinant cia saugosim atspausdintu simboliu skaiciu
	
.code

Pradzia:
	MOV	ax, @data		
	MOV	ds, ax	

;*****************************************************
;Parametru tikrinimas
;*****************************************************
	MOV	bx, 0082h
Parametrai:	
	MOV	ax, es:[bx]	         
	INC	bx  

	MOV	ch, 0
	MOV	cl, es:[0080h]				;cia ivesta kokio ilgio parametrai
	CMP     cx, 0                  			;jei nieko neivesta	
	JE	help
	CMP	al, 20h         			;ar tarpo simbolis?  
	JE  	help	
	CMP 	ax, "?/"        			;ar prasoma autoriaus   
	JE 	autorius	
	JMP	splitkiekis1				;jei praeina parametru testus, tesiam ir pradedam skaityti informacija

Autorius:
	MOV	dx, offset info  			;ispausdina autoriu ir programos informacija
	MOV	ah, 09h            
	INT	21h                
	JMP 	Exit        

Help:
	MOV	dx, offset helpas  			;help eilute, jei nieko neiveda
	MOV 	ah, 09h            
	INT 	21h  
	JMP 	Exit              
	
;*****************************************************
;Kiekio nuskaitymas					;nusiskaicius kieki, ji reikia paverst is hex i decimal, kad butu galima naudoti normaliai, cia tai daro
;*****************************************************	
splitkiekis1: 
   	MOV 	si, 0082h				;I bx idedame parametru adresa, parametrai visada patalpinti es segmente, 0082h adresu
	MOV	cx, 0                                      
splitkiekis2:    					;si dalis skirta surasti keliu skaitmenu ilgio yra "kiekis"
	MOV	dl, es:[si]
	CMP	dl, 20h					;pridedinesim kol rasim tarpa
	JE 	splitkiekis3
	INC	cx        
	INC 	si
	JMP	splitkiekis2
splitkiekis3:
	MOV	dx, 0
	MOV	si, 0082h 

	MOV	kiekissk, cx				; isirasom kiekis ilgi
	INC	kiekissk				; dar pastumam ilgi, kad po to iskart rodytu i failu pavadinimus, o ne i tarpa

        MOV	ax, 0					; isvalom daugybai
Ciklas:
	CMP 	es:byte ptr[si], 30h			; tikrinam ar ivestas simbolis yra >= uz '0' (30h)
	JNB 	toliau1					; toks trumpas jumpas, kada exit yra programos gale ir JA nenusoka tiek
	JMP	exit					; jei ne, vadinas ivestas ne skaicius, nutraukiam programa.
toliau1:						
	CMP 	es:byte ptr[si], 39h			; tikrinam ar ivestas simbolis yra <= uz '9' (39h)
	JBE	toliau2
	JMP	exit
toliau2:

	SUB 	es:byte ptr[si], 30h			; atimam 30h (48), kad isreikstume skaiciu is simbolio kodo. 

	MUL	deci					; dauginam AX is 10
	MOV 	BL, es:byte ptr[si]			; i BL perkeliam skaiciu
	MOV 	BH, 0					; isvalom BH 
	ADD 	AX, BX					; prie AX pridedam BX

	INC 	si					; inkrementuojam SI, taip kitu ciklo apsisukimu pasiekdami sekanti skaiciu
		
	LOOP 	Ciklas					; cx=cx-1; jeigu cx<>0 eiti i ciklas
		
	MOV 	kiekis, AL				; sukonstruota skaiciu issaugom i kiekis 

;*****************************************************
;Vardu nusiskaitymas					;visus vardus nusiskaitom i bendra buferi
;*****************************************************
Vardas:	
	MOV 	bx, 0082h				;I bx idedame duomenu failo pavadinimo adresa
	ADD	bx, kiekissk				;pridedam prie adreso skaiciaus ilgi, kad rodytu i pavadinimus iskart
	MOV 	di, offset duomvisi 			;di priskiriam duom adresa
	DEC 	di

Duomfailai:
	MOV 	ax, es:[bx]				;imame du baitus (ax yra dvieju baitu registras), nors naudosime tik 1 baita
	INC 	bx
	
	CMP 	al, 13					;jei enteris, suprantama kaip vardu pabaiga
	JE	Isejimas	
	
	MOV 	byte [di], al 				;irasome adresu di baita al (raide)
	ADD 	di, 1 					;paslenkame adresa vienetu
	
	JMP	DuomFailai 				;imame kita simboli
Isejimas:

;*****************************************************
;Darbo pradzia
;*****************************************************
	MOV	si, offset duomvisi
Darbopradzia1:					;sioje dalyje isirasom failu pradines koordinates
	
	MOV	di, offset duom			;ikeliam i di failo vardo adresa
	INC	di				;padidinam di, nes pirma vieta paliekam skaiciui	
	MOV	bx, 0				;bus skaitliukas skaitant pavadinima
	
Darbopradzia2:					;nusiskaitysim pavadinima

	MOV	al, [si+bx]
	CMP	al, 20h					;tikrinam ar dar ne tarpas
	JE	darbas	
	CMP 	al, 00					;jei preinam parametru gala
	JE	darbas
	MOV	[di+bx], al
	INC	bx
	JMP	darbopradzia2
darbas:
	ADD	si, bx  
	INC 	si
	MOV 	pasksimb, al
	
	PUSH 	AX
	PUSH 	BX
	PUSH 	CX
	PUSH 	DX
;*************Failo atsidarymas*************
Skaitymas:
	MOV	ah, 3Dh					;21h pertraukimo failo atidarymo funkcijos numeris
	MOV	al, 00					;00 - failas atidaromas skaitymui
	MOV	dx, offset duom				;vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INC 	dx                     			;skaitant skaitom vienu toliau, nes pirmas skaicius duom kintamajame paliktas indeksui
	INT	21h					;failas atidaromas skaitymui
	JNC 	Nieko1
	JMP	exit					;jei atidarant faila skaitymui ivyksta klaida, nustatomas carry flag 	
Nieko1:
	MOV	dFail, ax				;atmintyje isisaugom duomenu failo deskriptoriaus numeri


;********Failo nuskaitymas i skbuf**********
Skaityk:
	MOV	bx, dFail				;i bx iraom duomenu failo deskriptoriaus numeri
	CALL	SkaitykBuf				;ikvieciame skaitymo i failo procedura
	CMP	ax, 0					;ax iraoma, kiek baitu buvo nuskaityta, jeigu 0 - pasiekta failo pabaiga
	JNE 	Nieko3
	JMP	exit 
Nieko3:     

    	MOV	spausdsk, 0				;failo numeris, pradesim nuo 1
    	MOV 	simblike, ax
    	MOV 	simbbuve, 0 		
;****surandam, kiek failu reiks irasyti***** 
	DIV	kiekis
	CMP	ah, 0
	JE	galas0
	INC	ax 
	MOV 	cx, ax 
	MOV 	ch, 0  
galas0:
    	MOV cx, ax 
	MOV ch, 0
galas:                     
	INC spausdsk
	PUSH cx 

;****failo sukurimas rasymui***** 
   	MOV 	bl, spausdsk
    	ADD 	bl, 30h 
    	MOV 	duom[0], bl 
	MOV	ah, 3Ch					;21h pertraukimo failo sukurimo funkcijos numeris
	MOV	cx, 0					;kuriamo failo atributai
	MOV	dx, offset duom			;vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INT	21h					;sukuriamas failas; jei failas jau egzistuoja, visa jo informacija itrinama
	MOV	rFail, ax				;atmintyje isisaugom rezultato failo deskriptoriaus numeri  	
      
;****irasymas i faila*******
   	MOV 	dx, simblike
    	MOV 	cl, kiekis
    	MOV 	ch, 00 
    	CMP 	dx, cx
    	JB  	lastirasimas
    
   	MOV 	ah, 40h
	MOV 	dx, offset skbuf
	ADD 	dx, simbbuve
	MOV 	ch, 0
	MOV 	cl, kiekis
	MOV 	bx, rfail
	INT 	21h
	ADD 	simbbuve, cx
	SUB 	simblike, cx
	JMP 	irasyta       
lastirasimas:
    	MOV 	ah, 40h
	MOV 	dx, offset skbuf
	ADD 	dx, simbbuve
	MOV 	cx, simblike
	MOV 	bx, rfail
	INT 	21h    
    
irasyta:  

;****failo uzdarymas***** 
   	MOV	ah, 3Eh					;21h pertraukimo failo udarymo funkcijos numeris
	MOV	bx, rFail				;i bx iraom rezultato failo deskriptoriaus numeri
	INT	21h					;failo udarymas

    	POP 	cx    
    	LOOP 	galas    

    INC di  
;*****************Duomenu failo udarymas*******
uzdarytiSkaitymui:
	MOV	ah, 3Eh					;21h pertraukimo failo udarymo funkcijos numeris
	MOV	bx, dFail				;i bx iraom duomenu failo deskriptoriaus numeri
	INT	21h					;failo udarymas
	JC	exit					;jei udarant faila ivyksta klaida, nustatomas carry flag	

	POP DX
	POP CX
	POP BX
	POP AX    
	
	CMP 	pasksimb, 00
	JE 	toliauu 
	JMP 	darbopradzia1
	
toliauu:
    JMP exit


	
;*****************************************************
;Procedura nuskaitanti informacija i failo
;*****************************************************
PROC SkaitykBuf
;i BX paduodamas failo deskriptoriaus numeris
;i AX bus grainta, kiek simboliu nuskaityta
	PUSH	cx
	PUSH	dx
	
	MOV	ah, 3Fh					;21h pertraukimo duomenu nuskaitymo funkcijos numeris
	MOV	cx, skBufDydis				;cx - kiek baitu reikia nuskaityti i failo
	MOV	dx, offset skBuf			;vieta, i kuria iraoma nuskaityta informacija
	INT	21h					;skaitymas i failo
	JC	KlaidaSkaitant				;jei skaitant i failo ivyksta klaida, nustatomas carry flag
		
SkaitykBufPabaiga:
	POP	dx
	POP	cx
	RET 0

KlaidaSkaitant:
	MOV 	ax, 0					;Paymime registre ax, kad nebuvo nuskaityta ne vieno simbolio
	JMP	SkaitykBufPabaiga
SkaitykBuf ENDP	

;*****************************************************
;Pabaiga
;*****************************************************
Exit:
	MOV	ah, 4Ch						
	MOV	al, 0						
	INT	21h							
END pradzia
	

